Inhalte
Index 🔎︎

# Anweisung GoSub...Return

Ruft innerhalb einer Prozedur oder Funktion eine durch ein Label gekennzeichnete Subroutine auf. Die Anweisungen nach dem Label werden bis zur nächsten Anweisung Return ausgeführt. Danach wird die Programmausführung bei der Anweisung fortgesetzt, die auf die Anweisung GoSub folgt.

## Syntax:

    siehe Parameter

## Parameter:

Sub/Function

Befehlsblock

Beschriftung

Befehlsblock

GoSub Marke

Exit Sub/Function

Marke:

Befehlsblock

Return

End Sub/Function

Die Anweisung GoSubruft innerhalb einer Prozedur oder Funktion eine lokale, durch ein Label gekennzeichnete Subroutine auf. Der Name des Labels muss mit einem Doppelpunkt (":") aufhören.

Trifft das Programm auf eine Return-Anweisung, ohne dass zuvor ein GoSub erfolgte, meldet LibreOffice Basic eine Fehlermeldung. Sie müssen selber dafür Sorge tragen, dass Ihr Programm ein Unterprogramm oder eine Funktion mit der Anweisung Exit Sub beziehungsweise der Anweisung Exit Function (siehe dort) verlässt, bevor es auf einen Programmteil stößt, der mit Return abgeschlossen ist.

Das folgende Beispiel demonstriert die Verwendung von GoSub und Return. Das Programm berechnet die Quadratwurzeln zweier vom Benutzer eingegebener Zahlen, indem es einen bestimmten Programmabschnitt zweimal ausführt.

## Beispiel:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox("Bitte geben Sie die erste Zahl ein: ","Zahleingabe"))
        iInputb = Int(InputBox("Bitte geben Sie die zweite Zahl ein: ","Zahleingabe"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "Die Quadratwurzel aus";iInputa;" ist";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "Die Quadratwurzel aus";iInputb;" ist";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub